今天要讲的是关于NX软件录制宏操作的一些案例。
下面讲如何在NX软件中复制Part体的录制宏。
NXOpen.Session theSession = NXOpen.Session.GetSession();
NXOpen.Part workPart = theSession.Parts.Work;
NXOpen.Part displayPart = theSession.Parts.Display;
NXOpen.Matrix3x3 rotMatrix1 = new NXOpen.Matrix3x3();
rotMatrix1.Xx = 0.89306013796526285;
rotMatrix1.Xy = -0.44496658771914138;
rotMatrix1.Xz = 0.066695770413509187;
rotMatrix1.Yx = -0.39632123815418213;
rotMatrix1.Yy = -0.70777276650451371;
rotMatrix1.Yz = 0.58479670585809584;
rotMatrix1.Zx = -0.21300954477535283;
rotMatrix1.Zy = -0.5486915771251909;
rotMatrix1.Zz = -0.80843335348466772;
NXOpen.Point3d translation1 = new NXOpen.Point3d(-52.577957389047107, 41.350418114859622, 62.806893022449373);
workPart.ModelingViews.WorkView.SetRotationTranslationScale(rotMatrix1, translation1, 0.68000460164672882);
// ----------------------------------------------
// 菜单:编辑(E)->复制(C)
// ----------------------------------------------
workPart.PmiManager.RestoreUnpastedObjects();
// ----------------------------------------------
// 菜单:编辑(E)->粘贴(P)
// ----------------------------------------------
NXOpen.Session.UndoMarkId markId1;
markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "起点");
NXOpen.NXObject[] features1 = new NXOpen.NXObject[1];
NXOpen.Features.Brep brep1 = ((NXOpen.Features.Brep)workPart.Features.FindObject("UNPARAMETERIZED_FEATURE(12)"));
features1[0] = brep1;
NXOpen.Features.CopyPasteBuilder copyPasteBuilder1;
copyPasteBuilder1 = workPart.Features.CreateCopyPasteBuilder2(features1);
copyPasteBuilder1.SetBuilderVersion((NXOpen.Features.CopyPasteBuilder.BuilderVersion)(7));
NXOpen.Features.FeatureReferencesBuilder featureReferencesBuilder1;
featureReferencesBuilder1 = copyPasteBuilder1.GetFeatureReferences();
NXOpen.Point3d origin1 = new NXOpen.Point3d(0.0, 0.0, 0.0);
NXOpen.Vector3d normal1 = new NXOpen.Vector3d(0.0, 0.0, 1.0);
NXOpen.Plane plane1;
plane1 = workPart.Planes.CreatePlane(origin1, normal1, NXOpen.SmartObject.UpdateOption.WithinModeling);
NXOpen.Unit unit1 = ((NXOpen.Unit)workPart.UnitCollection.FindObject("MilliMeter"));
NXOpen.Expression expression1;
expression1 = workPart.Expressions.CreateSystemExpressionWithUnits("0", unit1);
NXOpen.Expression expression2;
expression2 = workPart.Expressions.CreateSystemExpressionWithUnits("0", unit1);
featureReferencesBuilder1.AutomaticMatch(true);
theSession.SetUndoMarkName(markId1, "粘贴特征 对话框");
NXOpen.Features.MatchedReferenceBuilder[] matchedReferenceData1;
matchedReferenceData1 = featureReferencesBuilder1.GetMatchedReferences();
NXOpen.Session.UndoMarkId markId2;
markId2 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Invisible, "粘贴特征");
theSession.DeleteUndoMark(markId2, null);
NXOpen.Session.UndoMarkId markId3;
markId3 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Invisible, "粘贴特征");
NXOpen.NXObject nXObject1;
nXObject1 = copyPasteBuilder1.Commit();
theSession.DeleteUndoMark(markId3, null);
theSession.SetUndoMarkName(markId1, "粘贴特征");
NXOpen.Features.Brep brep2 = ((NXOpen.Features.Brep)nXObject1);
NXOpen.Expression[] expressions1;
expressions1 = brep2.GetExpressions();
copyPasteBuilder1.Destroy();
今天要介绍的就是这么多,我们下篇文章再见。